import pandas as pd
import psycopg2 as psy
from getpass import getpass
import matplotlib.pyplot as plt
import numpy as np


fichier = open("login.txt","r")
login = fichier.read()
print(login)

co = None

try:
    co = psy. connect(
                        database ='db'+login,
                        user=login)

    curs = co.cursor()


    #? Calcule de la moyenne des prix des véhicules
    curs.execute('''SELECT AVG(Price) AS prix_moyen FROM Car;''')
    prix_moyen = np.ceil(curs.fetchone()[0])
    print("Le prix moyen d'une voiture est de", prix_moyen, "€")


    #? Calcule de l'écarts type des prix des véhicules
    curs.execute('''SELECT STDDEV(Price) AS ecart_type FROM Car;''')
    ecart_type = np.ceil(curs.fetchone()[0])
    print("L'écart type des prix des voitures est de", ecart_type)

    #? Calcule de la variences des prix des véhicules
    curs.execute('''SELECT VARIANCE(Price) AS variance FROM Car;''')
    variance = np.ceil(curs.fetchone()[0])
    print("La variance des prix des voitures est de", variance)

    #? Taille de l'échantillon
    curs.execute('''SELECT COUNT(*) AS taille_echantillon FROM Car;''')
    taille_echantillon = curs.fetchone()[0]
    print("La taille de l'échantillon est de", taille_echantillon, "voitures")

    #? Calcule de l'étendue des prix des véhicules
    curs.execute('''SELECT MAX(Price) - MIN(Price) AS etendue FROM Car;''')
    etendue = np.ceil(curs.fetchone()[0])
    print("L'étendue des prix des voitures est de", etendue, "€")


    # # #? Fonction qui retourne le prix moyen de la marque donnée en paramètre
    # curs.execute('''DROP FUNCTION IF EXISTS prix_moyen;
    #                     CREATE FUNCTION prix_moyen(marque varchar)
    #                     RETURNS numeric AS $$
    #                     DECLARE
    #                         moyenne numeric;
    #                     BEGIN
    #                         SELECT ROUND(AVG(Price)) INTO moyenne
    #                         FROM Car, Model
    #                         WHERE Car.model = Model.idModel
    #                         AND Model.Brand = marque;
    #                         RETURN moyenne;
    #                     END ;
    #                     $$ LANGUAGE plpgsql;''',co)

    # # #? Utilise la fonction SQL d'au dessus pour pouvoir récuperer les prix moyen des marque individuellement
    # def prix_moyen(marque) :
    #     curs.execute('''SELECT prix_moyen('{0}')'''.format(marque),co)
    #     moyenne = np.ceil(curs.fetchone()[0])
    #     print("Moyenne de prix de vente pour la marque {0} : {1} €".format(marque,moyenne))

    # prix_moyen('Ferrari')
    # prix_moyen('Toyota')

    # ?* Répartition des prix : 
    # * répartition des prix des voitures dans le jeu de données. 
    # * Cela peut donner une idée de la plage de prix dans laquelle se situent la plupart des voitures.
    # datafr = pd.read_sql('''SELECT Price AS prix, COUNT(*) AS nb_voitures 
    #                     FROM Car
    #                     GROUP BY Price;''', co)

    # # Create price bins
    # price_bins = [0, 10000, 20000, 30000, 40000, 50000, 60000, 70000, 80000, 90000, 100000, 200000]
    # labels=['0-10000', '10000-20000', '20000-30000', '30000-40000', '40000-50000', '50000-60000', '60000-70000', '70000-80000', '80000-90000', '90000-100000', '>100000']
    # datafr['price_range'] = pd.cut(datafr['prix'], bins=price_bins, labels=labels)

    # # Group by price range and count number of cars
    # datafr_by_range = datafr.groupby('price_range')['nb_voitures'].sum()

    # # Plot the data
    # datafr_by_range.plot(kind='bar', xlabel='Prix', ylabel='Nombre de voitures',
    #                     title='Fréquences des voitures en fonction de leur prix', color='orange')

    # plt.show()


    # #? Relation entre l'année de sortie et le prix : 
    # #* il y a une corrélation positive entre l'année de fabrication et le prix, 
    # #* ce qui signifie que les véhicules plus récentes ont tendance à être plus chères 
    # #* que les véhicules plus anciennes. À part les véhicules de collections 
    # #* comme on peut le voir avant les années 90.
    # datafr = pd.read_sql('''SELECT Year AS year, AVG(Price) AS prix_moyen 
    #                           FROM Car 
    #                           GROUP BY Year 
    #                           ORDER BY Year;''', co)
    # datafr['year'] = datafr['year'].astype(int)
    # datafr = datafr.plot.bar(x='year', y='prix_moyen', xlabel='Année', ylabel='Prix moyen', 
    #                           title='Prix moyen d\'un véhicule en fonction de son année de sortie', color='red')
    # plt.show()

    # #? Relation entre le kilométrage et le prix : 
    # #* il y a une corrélation négative entre le kilométrage et le prix, 
    # #* ce qui signifie que les véhicules ayant un kilométrage plus élevé ont 
    # #* tendance à être moins chères que les véhicules ayant un kilométrage plus faible.
    # #* À part les véhicules de collections qui peuvent posseder un kilométrage plus élevé (> 200 000).
    # datafr = pd.read_sql('''SELECT Kilometer AS kilometrage, AVG(Price) AS prix_moyen 
    #                           FROM Car 
    #                           GROUP BY Kilometer 
    #                           ORDER BY Kilometer;''', co)
    # datafr['kilometrage'] = pd.cut(datafr['kilometrage'], bins=[0, 10000, 50000, 100000, 200000, float('inf')], 
    #                               labels=['<10K', '10K-50K', '50K-100K', '100K-200K', '>200K'], include_lowest=True)
    # datafr = datafr.groupby('kilometrage')['prix_moyen'].mean().reset_index()
    # datafr.plot.bar(x='kilometrage', y='prix_moyen', xlabel='Kilométrage', ylabel='Prix moyen', 
    #                   title='Prix moyen d\'un véhicule en fonction de son kilométrage', color='red')
    # plt.show()

    #? Relation entre le type de carburant et le prix : 
    #* les véhicules fonctionnant à l'essence sont en moyenne moins chères 
    #* que les véhicules fonctionnant au diesel mais les véhicules 
    #* hybrides restent les plus chère sur le marché.
    datafr = pd.read_sql('''SELECT Model.FuelType AS carburant, COUNT(*) AS nb_voitures 
                       FROM Car 
                       JOIN Model ON Car.Model = Model.idModel 
                       GROUP BY Model.FuelType 
                       ORDER BY nb_voitures DESC;''', co)

    datafr['nb_voitures'] = datafr['nb_voitures'].astype(float)

    top_categories = datafr.head(2)
    other_count = datafr['nb_voitures'].sum() - top_categories['nb_voitures'].sum()
    top_categories.loc[4] = ['Others', other_count]

    plt.pie(top_categories['nb_voitures'], labels=top_categories['carburant'], autopct='%1.1f%%',
            colors=['orange', 'blue', 'green', 'gray'])

    plt.title('Pourcentage de voiture en fonction du type de carburant')
    plt.show()


    # #? Relation entre le type de vendeur et le prix :
    #* les voitures vendues par des concessionnaires ont tendance 
    #* à être plus chères que celles vendues par des propriétaires.
    datafr = pd.read_sql('''SELECT SellerType AS vendeur, AVG(Price) AS prix_moyen 
                              FROM Car 
                              GROUP BY SellerType 
                              ORDER BY prix_moyen;''', co)
    datafr = datafr.plot.bar(x='vendeur', y='prix_moyen', xlabel='Vendeur', ylabel='Prix moyen', 
                              title='Prix moyen des voitures par vendeur', color='orange')
    plt.show()

    # # #? Relation entre la puissance du moteur et le prix :
    # # #* il y a une corrélation positive entre la puissance du moteur et le prix,
    # # #* ce qui signifie que les véhicules ayant une puissance plus élevée ont tendance
    # # #* à être plus chères que les véhicules ayant une puissance plus faible.
    # # #* À part les véhicules de collections qui peuvent posseder une puissance plus élevée (> 5000).
    # df = pd.read_sql('''SELECT Engine AS puissance, AVG(Price) AS prix_moyen 
    #                 FROM Car 
    #                 INNER JOIN Model ON Car.Model = Model.idModel 
    #                 GROUP BY puissance 
    #                 ORDER BY prix_moyen DESC;''', co)

    # df['puissance'] = df['puissance'].astype(str).str.replace('cc', '').astype(float)

    # df['puissance_range'] = pd.cut(df['puissance'], 
    #                             bins=[0, 1000, 1500, 2000, 2500, 3000, 4000, 5000, float('inf')], 
    #                             labels=['<1000', '1000-1500', '1500-2000', '2000-2500', '2500-3000', 
    #                                     '3000-4000', '4000-5000', '>5000'], include_lowest=True)
    # datafr = df.groupby('puissance_range')['prix_moyen'].mean().reset_index()
    # datafr.plot.bar(x='puissance_range', y='prix_moyen', xlabel='Puissance moteur (en cc)', 
    #                 ylabel='Prix moyen (en euros)', title='Prix moyen des voitures par tranche de puissance moteur', color='red')
    # plt.show()



    # # #? Relation entre le type de transmission et le prix :
    # # #* les voitures avec une transmission automatique sont en moyenne
    # # #* plus chères que celles avec une transmission manuelle.
    # datafr = pd.read_sql('''SELECT m.Transmission AS transmission, AVG(c.Price) AS prix_moyen 
    #                         FROM Car c, Model m
    #                         WHERE c.Model = m.idModel
    #                         GROUP BY transmission 
    #                         ORDER BY prix_moyen;''', co)
        
    # datafr.plot.bar(x='transmission', y='prix_moyen', xlabel='Transmission', 
    #                 ylabel='Prix moyen', title='Prix moyen des voitures par transmission', color='orange')
    # plt.show()


    # #? relation entre le nombre de propriétaires précédents et le prix : 
    # #* il y a une corrélation négative entre le nombre de propriétaires précédents et le prix, 
    # #* ce qui signifie que les voitures ayant été possédées par un plus grand nombre de propriétaires
    # #*  ont tendance à être moins chères.
    # datafr = pd.read_sql('''SELECT Owner AS proprietaires, AVG(Price) AS prix_moyen
    #                         FROM Car
    #                         GROUP BY Owner
    #                         ORDER BY prix_moyen;''', co)
    # datafr = datafr.sort_values('proprietaires')  # Triez le DataFrame par la colonne 'proprietaires'
    # datafr = datafr.plot.bar(x='proprietaires', y='prix_moyen', xlabel='Nombre de propriétaires',
    #                         ylabel='Prix moyen', title='Prix moyen des voitures par nombre de propriétaires', color='red')
    # plt.show()

    # # #? relation entre le nombre de sièges et le prix :
    # # #* il y a une corrélation positive entre le nombre de sièges et le prix,
    # # #* ce qui signifie que les voitures ayant un plus grand nombre de sièges ont tendance à être plus chères.
    # datafr = pd.read_sql('''SELECT m.SeatingCapacity AS sieges, AVG(c.Price) AS prix_moyen
    #                         FROM Car c
    #                         INNER JOIN Model m ON c.Model = m.idModel
    #                         GROUP BY m.SeatingCapacity
    #                         ORDER BY prix_moyen''', co)

    # datafr = datafr.plot.bar(x='sieges', y='prix_moyen', xlabel='Nombre de sièges', 
    #                         ylabel='Prix moyen', title='Prix moyen des voitures par nombre de sièges', color='blue')
    # plt.show()


    # # #? relation entre la longueur du véhicule et son prix :
    # # #* il y a une corrélation positive entre la longueur du véhicule et le prix,
    # # #* ce qui signifie que les voitures ayant une plus grande longueur ont tendance à être plus chères.
    # df = pd.read_sql('''SELECT Length AS longueur, AVG(Price) AS prix_moyen
    #                 FROM Car
    #                 INNER JOIN Model ON Car.Model = Model.idModel
    #                 GROUP BY longueur
    #                 ORDER BY prix_moyen DESC;''', co)

    # df['longueur_range'] = pd.cut(df['longueur'], 
    #                             bins=[0, 350, 400, 450, 500, 550, float('inf')], 
    #                             labels=['<3500', '3500-4000', '4000-4500', '4500-5000', '5000-5500', '>5500'], include_lowest=True)
    # datafr = df.groupby('longueur_range')['prix_moyen'].mean().reset_index()
    # datafr.plot.bar(x='longueur_range', y='prix_moyen', xlabel='Longueur du véhicule (en cm)',
    #                 ylabel='Prix moyen (en euros)', title='Prix moyen des voitures par tranche de longueur', color='orange')
    # plt.show()


    # # #? relation entre la couleur et le prix :
    # # #* on peut donc remarquer que la couleur peut influer sur le prix d'une voiture.
    # # #* Car le jaune ou le noir sont, en moyenne, plus chers que les autres couleurs.
    # datafr = pd.read_sql('''SELECT Color AS couleur, AVG(Price) AS prix_moyen
    #                         FROM Car
    #                         GROUP BY Color
    #                         ORDER BY prix_moyen;''', co)
    # datafr = datafr.plot.bar(x='couleur', y='prix_moyen', xlabel='Couleur',
    #                         ylabel='Prix moyen', title='Prix moyen des voitures par couleur', color='blue')
    # plt.show()


    # #? trouver les marques dont le CEO est le Founder
    # # affiche rien car aucun ceo est le founder
    # curs.execute('''SELECT DISTINCT Brand.Name
    #                 FROM Brand
    #                 JOIN Person founder ON Brand.Name = founder.Brand AND founder.Job = 'Founder'
    #                 JOIN Person ceo ON Brand.Name = ceo.Brand AND ceo.Job = 'CEO' AND ceo.Name = founder.Name;''', co)
    # print(curs.fetchall())


    # # #? moyenne de prix des voitures selon l'année de création de la marque
    # df = pd.read_sql('''SELECT Brand.CreationDate AS annee_creation, AVG(Car.Price) AS prix_moyen
    #                 FROM Car
    #                 INNER JOIN Model ON Car.Model = Model.idModel
    #                 INNER JOIN Brand ON Model.Brand = Brand.Name
    #                 GROUP BY annee_creation
    #                 ORDER BY annee_creation ASC;''', co)
    # df['annee_creation'] = df['annee_creation'].astype(int)
    # df = df.sort_values('annee_creation', ascending=True)
    # ax = df.plot.bar(x='annee_creation', y='prix_moyen', xlabel="Année de création de la marque",
    #                 ylabel='Prix moyen (en euros)', title="Prix moyen des voitures par année de création de la marque", color='blue')
    # plt.show()

    
    co.commit ()
    curs.close ()
except (Exception , psy.DatabaseError ) as error :
    print ( error )
finally :
    if co is not None:
        co.close ()